summaryrefslogtreecommitdiff
path: root/dev-python
diff options
context:
space:
mode:
authorLiguros - Gitlab CI/CD [develop] <gitlab@liguros.net>2020-11-22 12:27:48 +0000
committerLiguros - Gitlab CI/CD [develop] <gitlab@liguros.net>2020-11-22 12:27:48 +0000
commitf065f4b190dae85d18eb808c985ec5cc57beeb3f (patch)
tree60b5a4a50ba0258cef45dbc6cb2753ab3ca1090b /dev-python
parentc67011c0a97d6697e4b0c823b68cd6e304f029a2 (diff)
downloadbaldeagleos-repo-f065f4b190dae85d18eb808c985ec5cc57beeb3f.tar.gz
baldeagleos-repo-f065f4b190dae85d18eb808c985ec5cc57beeb3f.tar.xz
baldeagleos-repo-f065f4b190dae85d18eb808c985ec5cc57beeb3f.zip
Updating liguros repo
Diffstat (limited to 'dev-python')
-rw-r--r--dev-python/pylatex/Manifest2
-rw-r--r--dev-python/pylatex/pylatex-1.4.1.ebuild (renamed from dev-python/pylatex/pylatex-1.3.3.ebuild)7
-rw-r--r--dev-python/pypy-exe-bin/Manifest2
-rw-r--r--dev-python/pypy-exe-bin/pypy-exe-bin-7.3.3.ebuild48
-rw-r--r--dev-python/pypy-exe/Manifest1
-rw-r--r--dev-python/pypy-exe/pypy-exe-7.3.3.ebuild167
-rw-r--r--dev-python/pypy/Manifest1
-rw-r--r--dev-python/pypy/pypy-7.3.3.ebuild176
-rw-r--r--dev-python/pypy3-exe-bin/Manifest4
-rw-r--r--dev-python/pypy3-exe-bin/pypy3-exe-bin-7.3.3.ebuild48
-rw-r--r--dev-python/pypy3-exe-bin/pypy3-exe-bin-7.3.3_p37.ebuild49
-rw-r--r--dev-python/pypy3-exe/Manifest2
-rw-r--r--dev-python/pypy3-exe/pypy3-exe-7.3.3.ebuild156
-rw-r--r--dev-python/pypy3-exe/pypy3-exe-7.3.3_p37.ebuild157
-rw-r--r--dev-python/pypy3/Manifest2
-rw-r--r--dev-python/pypy3/pypy3-7.3.3.ebuild207
-rw-r--r--dev-python/pypy3/pypy3-7.3.3_p37.ebuild178
-rw-r--r--dev-python/python-utils/python-utils-2.3.0.ebuild15
-rw-r--r--dev-python/tqdm/tqdm-4.53.0.ebuild4
19 files changed, 1212 insertions, 14 deletions
diff --git a/dev-python/pylatex/Manifest b/dev-python/pylatex/Manifest
index 65c065d5f204..772b2cf8d0ad 100644
--- a/dev-python/pylatex/Manifest
+++ b/dev-python/pylatex/Manifest
@@ -1,2 +1,2 @@
-DIST pylatex-1.3.3.tar.gz 300639 BLAKE2B ac8fad8fa7e6e821cda168f3ae8ffb5acec21d688761b153ef2f9383b6a2f2ac7daea65f04389eb1ba3152fc50176d73cb814a78d2b5250ead2c6647eb96635a SHA512 12f51805996d84840f68844b79384ce4d2c29dde4db06f73b8887fe012abeaa4b9c5cf5e449132e626132b50ba26f014a899d548e3c0def25289671fd92e41a6
DIST pylatex-1.4.0.tar.gz 301148 BLAKE2B 4d1fa6add43556b7b2c1ff13b3bc2130d06018499197c3d1f40c9180f4346e774d69c2a356d5eab6c8686957ebafac71a78506553cf7cd3cd57d03c0e0ffffd1 SHA512 0d9ab3e733c50b5a4dd7a6758193645c5532c9153972bbed244e3f7e2d6a946bd36af428197f9cdd1a3256f4cc0db5dc78248973f9b330684ce8651c4a59ad91
+DIST pylatex-1.4.1.tar.gz 301482 BLAKE2B c68c8bbf70c5099b3c3146922afe94dcf4f90bfc8644fa165ee27835f4a24642645f9849f2f9fd69656dc07dcc4807869275aacf33a1e5b9c59e539801f8e821 SHA512 55a5734e4d239cef4bcaafa0ba64eea013ba3e86d137de5a5f8311d70c949d783e2e7aad24d39d16a6febbe4bddc34e47248068e1328fe3f95f39a7c7019a3a9
diff --git a/dev-python/pylatex/pylatex-1.3.3.ebuild b/dev-python/pylatex/pylatex-1.4.1.ebuild
index deb15e20bc05..f7b9a7e488dc 100644
--- a/dev-python/pylatex/pylatex-1.3.3.ebuild
+++ b/dev-python/pylatex/pylatex-1.4.1.ebuild
@@ -13,17 +13,18 @@ inherit distutils-r1 optfeature
DESCRIPTION="A Python library for creating LaTeX files and snippets"
HOMEPAGE="https://github.com/JelteF/PyLaTeX"
SRC_URI="https://github.com/JelteF/${MY_PN}/archive/v${PV}.tar.gz -> ${P}.tar.gz"
+S="${WORKDIR}/${MY_P}"
LICENSE="MIT"
SLOT="0"
-KEYWORDS="amd64 x86"
+KEYWORDS="~amd64 ~x86"
IUSE="examples"
RDEPEND="
dev-python/ordered-set[${PYTHON_USEDEP}]
"
-distutils_enable_tests nose
+distutils_enable_tests pytest
BDEPEND+="
test? (
@@ -34,8 +35,6 @@ BDEPEND+="
dev-texlive/texlive-latexextra
)"
-S="${WORKDIR}/${MY_P}"
-
python_install_all() {
if use examples ; then
dodoc -r examples
diff --git a/dev-python/pypy-exe-bin/Manifest b/dev-python/pypy-exe-bin/Manifest
index fc2b38b03da2..689d3fd9f329 100644
--- a/dev-python/pypy-exe-bin/Manifest
+++ b/dev-python/pypy-exe-bin/Manifest
@@ -2,5 +2,7 @@ DIST pypy-exe-7.3.1-1.amd64.xpak 13578971 BLAKE2B 6ff3c64ec88813ef68d325cff5e2da
DIST pypy-exe-7.3.1-1.x86.xpak 10239654 BLAKE2B 2588e879e2bd3ea41938ec21f55167d118cb493680f8e7aded6d6c01bed6499efd65f7d7f56e305a4ebc2aab02adf9d58fceccb503dd0ff41e93c642baf2191c SHA512 110b202c805729bcd6789ea0f6c7bffe62ab23cbd33fcff572254f56f4da82e25f9f7f617c5a4b3911044c07ea33ae8d17bd8547bb7779ca517b973b553e6b1d
DIST pypy-exe-7.3.2-1.amd64.xpak 13541084 BLAKE2B 8af5c35d99275a2131d4b6c51f505a9bf3015a144387030c78a490c331f1fb34b69106ad6ed961247b4de6a39d2fde47a1ebad204e3a3569f269ed7ee32559de SHA512 82d99e896954aec8749154e19d42636608403e4c4bece34e72b5804208cb42ed26bfdf4506ab2579a3b74d7cede97ef66b313ae9feeddabbfd79045090dc3035
DIST pypy-exe-7.3.2-1.x86.xpak 10216001 BLAKE2B 934be623ce1afa9d0bfb1b3725e89d994352c9d57b9807c6fa135a0aabe3c50633566425b25ebf98f1cec8160eadf5305033ac3f3ba4cfff5fb7b39e5d19f9c6 SHA512 9d25f1d82af3ed1c4d046e5f3434d12ed4c02eee4cc8adb64a03159bb48cf114f393bd60c67223447796726f59b622f8462ac439446eb14dcf2e76983da635e8
+DIST pypy-exe-7.3.3-1.amd64.xpak 13533778 BLAKE2B de70f6b47e9908757ae73c047f04fc8081bb422f5ba6c0e9a865dde2c9aebfc881858194b107bb3e0110d61de718fb8fe7db2aac0885bb6adca101b12e6e400f SHA512 f98b86ed44567979234460fc9df7b79477729bdcc233ab8dd3ba991f80a5f32c9111f263ef4df5b2703581431d7f92ee468f057ce95613deaf35176634f253e2
+DIST pypy-exe-7.3.3-1.x86.xpak 10258112 BLAKE2B 55744bb2b68dee5b959c8976ad62b0e8e4d633f2b31003fc14d8bae82b4b55e7927ea1296501207ee2377df456b469ce3594a65a5171c84188ef22b88370a051 SHA512 baa895377c3cbd090971660edf3b634ada20390ed940c72ba2e9fadce30d3c88125f4c52b11d17160a1ba1331e648d2bed37d6d533866ea97d786634b5ecc0a7
DIST pypy-exe-7.3.3_rc1-1.amd64.xpak 13533939 BLAKE2B 9b959a51e5e896d68d5321ac27f661900eda5407e6682883cea00e6d7363c4a1287044da47a7e750ae93fe9801a8ca3ee4fc9846b679998f3fbddefc19a62593 SHA512 a0c73ec6e300f0f52ac8f8305e92670eec8aacb11f7cb345804f042ae40d514ea1be2b14511422791e46b758437af49e43d409a27fb0087bf881143f6b265f17
DIST pypy-exe-7.3.3_rc1-1.x86.xpak 10254396 BLAKE2B e3fa75dc753cc64baca69f802f2f52557b4b374801df7ede216c10f485130b2beb321d404e592e5de49d048de89f1a4496e946ebc8e7a831b1de7806d32e99a7 SHA512 6fae90183fea72dd913342fb230aca09091d0ef94f81a62750f39885bbaec78e227eb282372fe9f869ade1abdaac0ee7c93900311d495dc10735fb4573aaf52b
diff --git a/dev-python/pypy-exe-bin/pypy-exe-bin-7.3.3.ebuild b/dev-python/pypy-exe-bin/pypy-exe-bin-7.3.3.ebuild
new file mode 100644
index 000000000000..cbfcb9fce7dd
--- /dev/null
+++ b/dev-python/pypy-exe-bin/pypy-exe-bin-7.3.3.ebuild
@@ -0,0 +1,48 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+inherit pax-utils
+
+MY_P=pypy-exe-${PV}-1
+DESCRIPTION="PyPy executable (pre-built version)"
+HOMEPAGE="https://pypy.org/"
+SRC_URI="
+ amd64? (
+ https://dev.gentoo.org/~mgorny/binpkg/amd64/pypy/dev-python/pypy-exe/${MY_P}.xpak
+ -> ${MY_P}.amd64.xpak
+ )
+ x86? (
+ https://dev.gentoo.org/~mgorny/binpkg/x86/pypy/dev-python/pypy-exe/${MY_P}.xpak
+ -> ${MY_P}.x86.xpak
+ )"
+S="${WORKDIR}"
+
+LICENSE="MIT"
+SLOT="${PV}"
+KEYWORDS="~amd64 ~x86"
+
+RDEPEND=">=sys-libs/zlib-1.1.3:0/1
+ dev-libs/libffi:0/7
+ virtual/libintl:0/0
+ dev-libs/expat:0/0
+ app-arch/bzip2:0/1
+ sys-libs/ncurses:0/6
+ !dev-python/pypy-exe:${PV}"
+
+QA_PREBUILT="
+ usr/lib/pypy2.7/pypy-c-${SLOT}"
+
+src_unpack() {
+ ebegin "Unpacking ${MY_P}.${ARCH}.xpak"
+ tar -x < <(xz -c -d --single-stream "${DISTDIR}/${MY_P}.${ARCH}.xpak")
+ eend ${?} || die "Unpacking ${MY_P} failed"
+}
+
+src_install() {
+ insinto /
+ doins -r usr
+ fperms +x "/usr/lib/pypy2.7/pypy-c-${SLOT}"
+ pax-mark m "${ED}/usr/lib/pypy2.7/pypy-c-${SLOT}"
+}
diff --git a/dev-python/pypy-exe/Manifest b/dev-python/pypy-exe/Manifest
index 3624fd594118..d4d8346024c7 100644
--- a/dev-python/pypy-exe/Manifest
+++ b/dev-python/pypy-exe/Manifest
@@ -1,3 +1,4 @@
DIST pypy2.7-v7.3.1-src.tar.bz2 21053306 BLAKE2B 071d59b7978c98e9ed9243d9a64d93d21b524351cb9a45e0f7d48828f919c84585a1164e7c38739fdd8828ab4b1eedade96dff7d64d0d9cbfe00c74d88d532bb SHA512 1bec44fa0fc4b1186e25f69303f9e332df32184be990d86fba41c40152664a93bd65eabf4dded133371271402cea9b150b60c13bce89d1004b276f0908c0b8f1
DIST pypy2.7-v7.3.2-src.tar.bz2 21142873 BLAKE2B e6bcd2dc28ef740962d053753ccd172e3895fc83fe23a319c003248e0986f9805839daddd13a0f480f1e9ee813979742699cb0bc8c42b6b05c193fedf67aea4f SHA512 b40d93d615a27e3a035007307a8ab2b49ff90f3047af914b268a80feb8219d372eca14c04a8b0dea91efb992653457b7c6d088c784de32c414cc48879f2d15fc
+DIST pypy2.7-v7.3.3-src.tar.bz2 20881821 BLAKE2B ce1ecdd1fffe40574c7662da6038b84d2bca47ab168939ef0c12be2c6348317f17a94a3026e7fa53c71601edc153aefd98f770bd148e7af07ca751c0a5fc1252 SHA512 c2b6c44fdcac5f9445fab01572f859228fc286891fd09a4ddb95d283683d805276c853ec8e61fcd04cb9ee811d0e959d19bb03fdd7442c044f28a773633122e7
DIST pypy2.7-v7.3.3rc1-src.tar.bz2 20933100 BLAKE2B afbf3c15924e6a215b6323fe97e9782912f09ba1e1db6652b37897ead07deaaa97f591a91f3695e958e8e2dee2626bbda94c4043c025b3f52a12279dc66e483c SHA512 0ddbdcf7ef825888ff748ebdd84cb501653e3a4a0e506e35810f9693b5d3b388c2f636396616f0c8fcc96dc806fa02d74830c1f37ca11fdcfdfd32c3bcd1fdd0
diff --git a/dev-python/pypy-exe/pypy-exe-7.3.3.ebuild b/dev-python/pypy-exe/pypy-exe-7.3.3.ebuild
new file mode 100644
index 000000000000..c0dee5cf1c60
--- /dev/null
+++ b/dev-python/pypy-exe/pypy-exe-7.3.3.ebuild
@@ -0,0 +1,167 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+PYTHON_COMPAT=( python2_7 )
+inherit check-reqs pax-utils python-any-r1 toolchain-funcs
+
+MY_P=pypy2.7-v${PV/_/}
+DESCRIPTION="PyPy executable (build from source)"
+HOMEPAGE="https://pypy.org/"
+SRC_URI="https://buildbot.pypy.org/pypy/${MY_P}-src.tar.bz2"
+S="${WORKDIR}/${MY_P}-src"
+
+LICENSE="MIT"
+SLOT="${PV}"
+KEYWORDS="~amd64 ~arm64 ~ppc64 ~x86 ~amd64-linux ~x86-linux"
+IUSE="bzip2 +jit low-memory ncurses cpu_flags_x86_sse2"
+
+RDEPEND=">=sys-libs/zlib-1.1.3:0=
+ dev-libs/libffi:0=
+ virtual/libintl:0=
+ dev-libs/expat:0=
+ bzip2? ( app-arch/bzip2:0= )
+ ncurses? ( sys-libs/ncurses:0= )
+ !dev-python/pypy-exe-bin:${PV}"
+# don't enforce the dep on pypy with USE=low-memory since it's going
+# to cause either collisions or circular dep on itself
+DEPEND="${RDEPEND}"
+BDEPEND="
+ !low-memory? (
+ || (
+ dev-python/pypy
+ dev-lang/python:2.7
+ )
+ )"
+
+check_env() {
+ if use low-memory; then
+ if ! has_version -b dev-python/pypy &&
+ ! has_version -b dev-python/pypy-bin
+ then
+ eerror "USE=low-memory requires a (possibly old) version of dev-python/pypy"
+ eerror "being installed. Please install it using e.g.:"
+ eerror
+ eerror " $ emerge -1v dev-python/pypy dev-python/pypy-exe-bin"
+ eerror
+ eerror "before attempting to build dev-python/pypy-exe[low-memory]."
+ die "dev-python/pypy needs to be installed for USE=low-memory"
+ fi
+
+ CHECKREQS_MEMORY="1750M"
+ use amd64 && CHECKREQS_MEMORY="3500M"
+ else
+ CHECKREQS_MEMORY="3G"
+ use amd64 && CHECKREQS_MEMORY="6G"
+ fi
+
+ check-reqs_pkg_pretend
+}
+
+pkg_pretend() {
+ [[ ${MERGE_TYPE} != binary ]] && check_env
+}
+
+pkg_setup() {
+ if [[ ${MERGE_TYPE} != binary ]]; then
+ check_env
+
+ use low-memory && EPYTHON=
+ if [[ ! ${EPYTHON} || ${EPYTHON} == pypy ]] &&
+ { has_version -b dev-python/pypy ||
+ has_version -b dev-python/pypy-bin; }
+ then
+ einfo "Using already-installed PyPy to perform the translation."
+ EPYTHON=pypy
+ else
+ einfo "Using ${EPYTHON} to perform the translation. Please note that upstream"
+ einfo "recommends using PyPy for that. If you wish to do so, please unset"
+ einfo "the EPYTHON variable."
+ python-any-r1_pkg_setup
+ fi
+ fi
+}
+
+src_configure() {
+ tc-export CC
+
+ local jit_backend
+ if use jit; then
+ jit_backend='--jit-backend='
+
+ # We only need the explicit sse2 switch for x86.
+ # On other arches we can rely on autodetection which uses
+ # compiler macros. Plus, --jit-backend= doesn't accept all
+ # the modern values...
+
+ if use x86; then
+ if use cpu_flags_x86_sse2; then
+ jit_backend+=x86
+ else
+ jit_backend+=x86-without-sse2
+ fi
+ else
+ jit_backend+=auto
+ fi
+ fi
+
+ local args=(
+ --no-shared
+ $(usex jit -Ojit -O2)
+
+ ${jit_backend}
+
+ pypy/goal/targetpypystandalone
+ )
+
+ # Avoid linking against libraries disabled by use flags
+ local opts=(
+ bzip2:bz2
+ ncurses:_minimal_curses
+ )
+
+ local opt
+ for opt in "${opts[@]}"; do
+ local flag=${opt%:*}
+ local mod=${opt#*:}
+
+ args+=(
+ $(usex ${flag} --withmod --withoutmod)-${mod}
+ )
+ done
+
+ local interp=( "${EPYTHON}" )
+ if use low-memory; then
+ interp=( env PYPY_GC_MAX_DELTA=200MB
+ "${EPYTHON}" --jit loop_longevity=300 )
+ fi
+
+ if [[ ${EPYTHON} != pypy ]]; then
+ # reuse bundled pycparser to avoid external dep
+ mkdir -p "${T}"/pymod/cffi || die
+ : > "${T}"/pymod/cffi/__init__.py || die
+ cp -r lib_pypy/cffi/_pycparser "${T}"/pymod/cffi/ || die
+ local -x PYTHONPATH=${T}/pymod:${PYTHONPATH}
+ fi
+
+ # translate into the C sources
+ # we're going to build them ourselves since otherwise pypy does not
+ # free up the unneeded memory before spawning the compiler
+ set -- "${interp[@]}" rpython/bin/rpython --batch --source "${args[@]}"
+ echo -e "\033[1m${@}\033[0m"
+ "${@}" || die "translation failed"
+}
+
+src_compile() {
+ emake -C "${T}"/usession*-0/testing_1
+}
+
+src_install() {
+ local dest=/usr/lib/pypy2.7
+ exeinto "${dest}"
+ newexe "${T}"/usession*-0/testing_1/pypy-c pypy-c-${PV}
+ insinto "${dest}"/include/${PV}
+ doins include/pypy_*
+ pax-mark m "${ED}${dest}/pypy-c-${PV}"
+}
diff --git a/dev-python/pypy/Manifest b/dev-python/pypy/Manifest
index 72d575304bde..8e407250474b 100644
--- a/dev-python/pypy/Manifest
+++ b/dev-python/pypy/Manifest
@@ -1,5 +1,6 @@
DIST pypy2.7-v7.3.1-src.tar.bz2 21053306 BLAKE2B 071d59b7978c98e9ed9243d9a64d93d21b524351cb9a45e0f7d48828f919c84585a1164e7c38739fdd8828ab4b1eedade96dff7d64d0d9cbfe00c74d88d532bb SHA512 1bec44fa0fc4b1186e25f69303f9e332df32184be990d86fba41c40152664a93bd65eabf4dded133371271402cea9b150b60c13bce89d1004b276f0908c0b8f1
DIST pypy2.7-v7.3.2-src.tar.bz2 21142873 BLAKE2B e6bcd2dc28ef740962d053753ccd172e3895fc83fe23a319c003248e0986f9805839daddd13a0f480f1e9ee813979742699cb0bc8c42b6b05c193fedf67aea4f SHA512 b40d93d615a27e3a035007307a8ab2b49ff90f3047af914b268a80feb8219d372eca14c04a8b0dea91efb992653457b7c6d088c784de32c414cc48879f2d15fc
+DIST pypy2.7-v7.3.3-src.tar.bz2 20881821 BLAKE2B ce1ecdd1fffe40574c7662da6038b84d2bca47ab168939ef0c12be2c6348317f17a94a3026e7fa53c71601edc153aefd98f770bd148e7af07ca751c0a5fc1252 SHA512 c2b6c44fdcac5f9445fab01572f859228fc286891fd09a4ddb95d283683d805276c853ec8e61fcd04cb9ee811d0e959d19bb03fdd7442c044f28a773633122e7
DIST pypy2.7-v7.3.3rc1-src.tar.bz2 20933100 BLAKE2B afbf3c15924e6a215b6323fe97e9782912f09ba1e1db6652b37897ead07deaaa97f591a91f3695e958e8e2dee2626bbda94c4043c025b3f52a12279dc66e483c SHA512 0ddbdcf7ef825888ff748ebdd84cb501653e3a4a0e506e35810f9693b5d3b388c2f636396616f0c8fcc96dc806fa02d74830c1f37ca11fdcfdfd32c3bcd1fdd0
DIST python-gentoo-patches-2.7.17-r1.tar.xz 14708 BLAKE2B f6e25236a471649de122d0f29506f7a4f34044a568ead47a68980411d9722b761fe1f9d653d5edccb6978b65c8c1eecbef55f403b94f32b37c0ad68e061505a8 SHA512 ecdde5e38c6fe5e69691fb3a68c8f4f43da7857d4abaff763d3cf6ad864ba43c769c03b186b60f2736a1ffb1e3e4c9982715d1b8a99ff3f5740096153bb8a90f
DIST python-gentoo-patches-2.7.18-r1.tar.xz 15500 BLAKE2B 7008b29827dbbd80d4ab8f010ccf9efced99c6b4b9109e4430c0ba269ce53529cb6fedd832502c8d2d3aa21938749cc3591c2545b21c0a59a6e60f8598e84ccc SHA512 e656ab07281fd932b92165674619bbf55ecf410d2937ae4ae771d490b4532540498cc731d30d19c1e8aafd1f64df8a406bbfbb46ea985b3dcd8edb89a0b7f20f
diff --git a/dev-python/pypy/pypy-7.3.3.ebuild b/dev-python/pypy/pypy-7.3.3.ebuild
new file mode 100644
index 000000000000..dfe53d9ae357
--- /dev/null
+++ b/dev-python/pypy/pypy-7.3.3.ebuild
@@ -0,0 +1,176 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+inherit pax-utils python-utils-r1
+
+MY_P=pypy2.7-v${PV/_/}
+# note: remember to update this to newest dev-lang/python:2.7 on bump
+PATCHSET="python-gentoo-patches-2.7.18-r1"
+
+DESCRIPTION="A fast, compliant alternative implementation of the Python language"
+HOMEPAGE="https://pypy.org/"
+SRC_URI="https://buildbot.pypy.org/pypy/${MY_P}-src.tar.bz2
+ https://dev.gentoo.org/~mgorny/dist/python/${PATCHSET}.tar.xz"
+S="${WORKDIR}/${MY_P}-src"
+
+LICENSE="MIT"
+# pypy -c 'import sysconfig; print sysconfig.get_config_var("SOABI")'
+SLOT="0/73"
+KEYWORDS="~amd64 ~arm64 ~ppc64 ~x86 ~amd64-linux ~x86-linux"
+IUSE="bzip2 gdbm +jit libressl ncurses sqlite tk"
+
+RDEPEND="
+ || (
+ dev-python/pypy-exe:${PV}[bzip2?,ncurses?]
+ dev-python/pypy-exe-bin:${PV}
+ )
+ !libressl? ( dev-libs/openssl:0= )
+ libressl? ( dev-libs/libressl:0= )
+ gdbm? ( sys-libs/gdbm:0= )
+ sqlite? ( dev-db/sqlite:3= )
+ tk? (
+ dev-lang/tk:0=
+ dev-tcltk/tix:0=
+ )
+ !<dev-python/pypy-bin-7.3.0:0"
+DEPEND="${RDEPEND}"
+
+src_prepare() {
+ eapply "${FILESDIR}/7.3.1-gentoo-path.patch"
+ eapply "${FILESDIR}/1.9-distutils.unixccompiler.UnixCCompiler.runtime_library_dir_option.patch"
+ eapply "${FILESDIR}/7.3.3-distutils-cxx.patch"
+
+ sed -e "s^@EPREFIX@^${EPREFIX}^" \
+ -i lib-python/2.7/distutils/command/install.py || die
+
+ # apply CPython stdlib patches
+ pushd lib-python/2.7 > /dev/null || die
+ # TODO: cpy turkish locale patch now fixes C code
+ # probably needs better port to pypy, if it is broken there
+ eapply -p2 "${WORKDIR}/${PATCHSET}"/0010-use_pyxml.patch
+ popd > /dev/null || die
+
+ # this test relies on pypy-c hardcoding correct build time paths
+ sed -i -e 's:test_executable_without_cwd:_&:' \
+ lib-python/2.7/test/test_subprocess.py || die
+ # requires Internet
+ sed -i -e '/class NetworkedTests/i@unittest.skip("Requires networking")' \
+ lib-python/2.7/test/test_ssl.py || die
+
+ eapply_user
+}
+
+src_compile() {
+ # copy over to make sys.prefix happy
+ cp -p "${BROOT}"/usr/lib/pypy2.7/pypy-c-${PV} pypy-c || die
+ cp -p "${BROOT}"/usr/lib/pypy2.7/include/${PV}/* include/ || die
+ # (not installed by pypy)
+ rm pypy/module/cpyext/include/_numpypy/numpy/README || die
+ mv pypy/module/cpyext/include/* include/ || die
+ mv pypy/module/cpyext/parse/*.h include/ || die
+ pax-mark m pypy-c
+
+ einfo "Generating caches and CFFI modules ..."
+
+ # Generate Grammar and PatternGrammar pickles.
+ ./pypy-c -c "import lib2to3.pygram, lib2to3.patcomp; lib2to3.patcomp.PatternCompiler()" \
+ || die "Generation of Grammar and PatternGrammar pickles failed"
+
+ # Generate cffi modules
+ # Please keep in sync with pypy/tool/build_cffi_imports.py!
+#cffi_build_scripts = {
+# "_ssl": "_ssl_build.py",
+# "sqlite3": "_sqlite3_build.py",
+# "audioop": "_audioop_build.py",
+# "tk": "_tkinter/tklib_build.py",
+# "curses": "_curses_build.py" if sys.platform != "win32" else None,
+# "syslog": "_syslog_build.py" if sys.platform != "win32" else None,
+# "gdbm": "_gdbm_build.py" if sys.platform != "win32" else None,
+# "pwdgrp": "_pwdgrp_build.py" if sys.platform != "win32" else None,
+# "resource": "_resource_build.py" if sys.platform != "win32" else None,
+ cffi_targets=( ssl audioop syslog pwdgrp resource )
+ use gdbm && cffi_targets+=( gdbm )
+ use ncurses && cffi_targets+=( curses )
+ use sqlite && cffi_targets+=( sqlite3 )
+ use tk && cffi_targets+=( tkinter/tklib )
+
+ local t
+ # all modules except tkinter output to .
+ # tkinter outputs to the correct dir ...
+ cd lib_pypy || die
+ for t in "${cffi_targets[@]}"; do
+ # tkinter doesn't work via -m
+ ../pypy-c "_${t}_build.py" || die "Failed to build CFFI bindings for ${t}"
+ done
+
+ # Cleanup temporary objects
+ find -name "_cffi_*.[co]" -delete || die
+ find -type d -empty -delete || die
+}
+
+src_test() {
+ # (unset)
+ local -x PYTHONDONTWRITEBYTECODE=
+ local -x COLUMNS=80
+
+ local ignored_tests=(
+ # network
+ --ignore=lib-python/2.7/test/test_urllibnet.py
+ --ignore=lib-python/2.7/test/test_urllib2net.py
+ # lots of free space
+ --ignore=lib-python/2.7/test/test_zipfile64.py
+ )
+
+ ./pypy-c ./pypy/test_all.py --pypy=./pypy-c -vv \
+ "${ignored_tests[@]}" lib-python || die
+}
+
+src_install() {
+ local dest=/usr/lib/pypy2.7
+ einfo "Installing PyPy ..."
+ dosym pypy-c-${PV} "${dest}/pypy-c"
+ insinto "${dest}"
+ # preserve mtimes to avoid obsoleting caches
+ insopts -p
+ doins -r include lib_pypy lib-python
+
+ # replace copied headers with symlinks
+ for x in "${BROOT}"/usr/lib/pypy2.7/include/${PV}/*; do
+ dosym "${PV}/${x##*/}" "${dest}/include/${x##*/}"
+ done
+
+ dosym ../lib/pypy2.7/pypy-c /usr/bin/pypy
+ dodoc README.rst
+
+ if ! use gdbm; then
+ rm -r "${ED}${dest}"/lib_pypy/gdbm.py \
+ "${ED}${dest}"/lib-python/*2.7/test/test_gdbm.py || die
+ fi
+ if ! use sqlite; then
+ rm -r "${ED}${dest}"/lib-python/*2.7/sqlite3 \
+ "${ED}${dest}"/lib_pypy/_sqlite3.py \
+ "${ED}${dest}"/lib-python/*2.7/test/test_sqlite.py || die
+ fi
+ if ! use tk; then
+ rm -r "${ED}${dest}"/lib-python/*2.7/{idlelib,lib-tk} \
+ "${ED}${dest}"/lib_pypy/_tkinter \
+ "${ED}${dest}"/lib-python/*2.7/test/test_{tcl,tk,ttk*}.py || die
+ fi
+
+ local -x EPYTHON=pypy
+ local -x PYTHON=${ED}${dest}/pypy-c-${PV}
+ # temporarily copy to build tree to facilitate module builds
+ cp -p "${BROOT}${dest}/pypy-c-${PV}" "${PYTHON}" || die
+
+ echo "EPYTHON='${EPYTHON}'" > epython.py || die
+ python_moduleinto /usr/lib/pypy2.7/site-packages
+ python_domodule epython.py
+
+ einfo "Byte-compiling Python standard library..."
+ python_optimize "${ED}${dest}"
+
+ # remove to avoid collisions
+ rm "${PYTHON}" || die
+}
diff --git a/dev-python/pypy3-exe-bin/Manifest b/dev-python/pypy3-exe-bin/Manifest
index 4a104ddd471e..1a0086f2133e 100644
--- a/dev-python/pypy3-exe-bin/Manifest
+++ b/dev-python/pypy3-exe-bin/Manifest
@@ -4,6 +4,10 @@ DIST pypy3-exe-7.3.2-r1-1.amd64.xpak 11745754 BLAKE2B 16b6b078609b6c6fb9f87c8d6f
DIST pypy3-exe-7.3.2-r1-1.x86.xpak 9030835 BLAKE2B 8fe13acd6bb93a60ed3f4268c1c53e7bb0101c7f68a58ddda4f7cec8fc5d4b3df463de2fbb585adbfb04349a96807a6c34246ceab76e001bfedabaddba90750b SHA512 ab463d5df575b1b8a01fa129f96b1317de37d2a0de83d124d411be63add0a241700a918885ed7128221cadfbb0d3b0d49d32d57ec25c59ec45e26e5bb1c4c0c0
DIST pypy3-exe-7.3.2_p37-r1-1.amd64.xpak 11864985 BLAKE2B 69fe7b080ec4fe6cf3d0e06c0d7c00c17627259d57ff02a1dc0629374f92f425889a3e40b075f48687af47e97b2504252369bd106011961337fe1708d6e35561 SHA512 673de3083be18d9f62e9586eb0daae3e1a041f245ffb17fabb0b88ee6262cdd3ffd7dc723e6b72eb42057d0bbffbcc82a5c2864e585c5a1b184983445269500e
DIST pypy3-exe-7.3.2_p37-r1-1.x86.xpak 9126391 BLAKE2B e8b68a1ce9ada6cf9a27dfcac78564d8a3020575ce9d1db7460c8aec8097abb6624bbce594d84556525253de8c620cb8acaf7e381af48d71b97bfdcfc5759a05 SHA512 29172e3d99775af10507167cd84f120677bfa752747b8d11f5434b16aea7eac9aa06bc820949cac132a2bd6e3c69df4da8a8a6bbba9cf4fe01db6cf1b0f725c6
+DIST pypy3-exe-7.3.3-1.amd64.xpak 11716026 BLAKE2B e57bc5e4420bb3d21f8ca9076f1795f33ba79fadb9ef6020a8597ac607e1173a11e440649a5ee7e308155ca28702e95aace36d5772f7ccc1d2c66b605a0c2a1d SHA512 462c1845f4566246df96abd59f2312fcd0ae1a9cf577ed6218aada4a95133f34a93f98a627fea5245ab79d9056fce00a2903503492e8f3e652a05b5832a5b67e
+DIST pypy3-exe-7.3.3-1.x86.xpak 9041169 BLAKE2B 47a2352407387d96214b0e297cc82504afe8b64378a528349a32d751ac3acb068bbf720165dae94582816a0372d85a8e9ccd9f8d5bf03c63a9f5d8cbc9463480 SHA512 c3c44c1448be6d861ca788e17ca79a4fd68fa1751f3d1f47d2570e1d924343e35e106fee30f7da5b3e14a679f5d9048d5bc263a8ef49cac420349acad67530ed
+DIST pypy3-exe-7.3.3_p37-1.amd64.xpak 11868037 BLAKE2B d23aa2c9dabbb1032ffce4176926f6996427dae05095c0842db3ac046e2234aef160cfcb84b9f2d146b76ae7315dd7d9c3c5ac974121ee876128f8977306e513 SHA512 7e26342c64a678058030bb38c29f5534c25694619942a66f4f507a615ee2798e2f631d81345ed269d252a3e68a79536e9248444c72563dddc1dc0a293457c76f
+DIST pypy3-exe-7.3.3_p37-1.x86.xpak 9133686 BLAKE2B ae8e82cf1820e93a08c85177ba1e6547afa4e063277617efc5ce658b890526f546e7e4d5accf37f2189cc8d5203625175fb5413482c21aded7006208a57afc19 SHA512 ec5d3a521cb1d784b1083f86c0693db180f31015b56feca85bb85ab35dd3d461fc96d31ad7aaf8031ec8e0488151fbd3049cac83bc0edac5df99b062b49eb481
DIST pypy3-exe-7.3.3_rc1-1.amd64.xpak 11732062 BLAKE2B 8e2a6fbfdf3a4ada68a3f7f4993b82ca93e254ab74c3ffe581dd8e813d96663fc172bed75019c1058e48af8b6b0cd6146847e21e854d26d1e54744cc69341d22 SHA512 673765c986b78a6a00ff913c624d9d0868f6471e1f942dfab19c61c027ea459608c76c3c5a88c8a19444e958a6b882839ab10eadc0ee0b5f02df0f6ff203518b
DIST pypy3-exe-7.3.3_rc1-1.x86.xpak 9036319 BLAKE2B d681c12cd496c9be7aea29bc9b6fbdbe1b30c38cfa511b39eae5ffb1a9b6ff06a5a728685ea8d0c0d2083dc153bd2a0c2d934381d60a1c89ba605abc629bd11c SHA512 f15f267b0e6f6edfee8aa501f9ce486612ccbbe6b60969247b81d1d0ada014704fb383d80fd93f875f2336268131884c513c02cf7396d5388019222edf41bbd1
DIST pypy3-exe-7.3.3_rc1_p37-1.amd64.xpak 11847540 BLAKE2B b817aac3c6a74295b4ee4c034b17600bb4400b9a50d61ff0dee1a969b68430d9121d92842435cd1e7e97b7540f343a78be95a4d857e0d8ee07c8cb4fe6388b13 SHA512 b6e1d6bbdb9092322e12e6edc190f588aef24dc90b6e332b23b9678cb68b149f4b029bf5f181b076907e9ce50b1114c4965e7636fc8e2077179c0a10e1376e7c
diff --git a/dev-python/pypy3-exe-bin/pypy3-exe-bin-7.3.3.ebuild b/dev-python/pypy3-exe-bin/pypy3-exe-bin-7.3.3.ebuild
new file mode 100644
index 000000000000..345dafd4e829
--- /dev/null
+++ b/dev-python/pypy3-exe-bin/pypy3-exe-bin-7.3.3.ebuild
@@ -0,0 +1,48 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+inherit pax-utils
+
+MY_P=pypy3-exe-${PV}-1
+DESCRIPTION="PyPy3 executable (pre-built version)"
+HOMEPAGE="https://pypy.org/"
+SRC_URI="
+ amd64? (
+ https://dev.gentoo.org/~mgorny/binpkg/amd64/pypy/dev-python/pypy3-exe/${MY_P}.xpak
+ -> ${MY_P}.amd64.xpak
+ )
+ x86? (
+ https://dev.gentoo.org/~mgorny/binpkg/x86/pypy/dev-python/pypy3-exe/${MY_P}.xpak
+ -> ${MY_P}.x86.xpak
+ )"
+S="${WORKDIR}"
+
+LICENSE="MIT"
+SLOT="${PV}"
+KEYWORDS="~amd64 ~x86"
+
+RDEPEND=">=sys-libs/zlib-1.1.3:0/1
+ dev-libs/libffi:0/7
+ virtual/libintl:0/0
+ dev-libs/expat:0/0
+ app-arch/bzip2:0/1
+ sys-libs/ncurses:0/6
+ !dev-python/pypy-exe:${PV}"
+
+QA_PREBUILT="
+ usr/lib/pypy3.6/pypy3-c-${SLOT}"
+
+src_unpack() {
+ ebegin "Unpacking ${MY_P}.${ARCH}.xpak"
+ tar -x < <(xz -c -d --single-stream "${DISTDIR}/${MY_P}.${ARCH}.xpak")
+ eend ${?} || die "Unpacking ${MY_P} failed"
+}
+
+src_install() {
+ insinto /
+ doins -r usr
+ fperms +x "/usr/lib/pypy3.6/pypy3-c-${SLOT}"
+ pax-mark m "${ED}/usr/lib/pypy3.6/pypy3-c-${SLOT}"
+}
diff --git a/dev-python/pypy3-exe-bin/pypy3-exe-bin-7.3.3_p37.ebuild b/dev-python/pypy3-exe-bin/pypy3-exe-bin-7.3.3_p37.ebuild
new file mode 100644
index 000000000000..e8930a159077
--- /dev/null
+++ b/dev-python/pypy3-exe-bin/pypy3-exe-bin-7.3.3_p37.ebuild
@@ -0,0 +1,49 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+inherit pax-utils
+
+MY_P=pypy3-exe-${PV}-1
+DESCRIPTION="PyPy3 executable (pre-built version)"
+HOMEPAGE="https://pypy.org/"
+SRC_URI="
+ amd64? (
+ https://dev.gentoo.org/~mgorny/binpkg/amd64/pypy/dev-python/pypy3-exe/${MY_P}.xpak
+ -> ${MY_P}.amd64.xpak
+ )
+ x86? (
+ https://dev.gentoo.org/~mgorny/binpkg/x86/pypy/dev-python/pypy3-exe/${MY_P}.xpak
+ -> ${MY_P}.x86.xpak
+ )"
+S="${WORKDIR}"
+
+LICENSE="MIT"
+SLOT="${PV}"
+KEYWORDS="~amd64 ~x86"
+
+RDEPEND=">=sys-libs/zlib-1.1.3:0/1
+ dev-libs/libffi:0/7
+ virtual/libintl:0/0
+ dev-libs/expat:0/0
+ app-arch/bzip2:0/1
+ sys-libs/ncurses:0/6
+ !dev-python/pypy-exe:${PV}"
+
+PYPY_PV=${SLOT%_p*}
+QA_PREBUILT="
+ usr/lib/pypy3.7/pypy3-c-${PYPY_PV}"
+
+src_unpack() {
+ ebegin "Unpacking ${MY_P}.${ARCH}.xpak"
+ tar -x < <(xz -c -d --single-stream "${DISTDIR}/${MY_P}.${ARCH}.xpak")
+ eend ${?} || die "Unpacking ${MY_P} failed"
+}
+
+src_install() {
+ insinto /
+ doins -r usr
+ fperms +x "/usr/lib/pypy3.7/pypy3-c-${PYPY_PV}"
+ pax-mark m "${ED}/usr/lib/pypy3.7/pypy3-c-${PYPY_PV}"
+}
diff --git a/dev-python/pypy3-exe/Manifest b/dev-python/pypy3-exe/Manifest
index 09c8da41a5db..06254507392c 100644
--- a/dev-python/pypy3-exe/Manifest
+++ b/dev-python/pypy3-exe/Manifest
@@ -1,5 +1,7 @@
DIST pypy3.6-v7.3.1-src.tar.bz2 22712809 BLAKE2B 4250b3fe98c611b9635319c106b80e88ab469eab5f883babb738e175e7b7adc22c85f8ef3fdce1cdc127b521beef8d6c7862e188d8c8889c39f90136d6bbe374 SHA512 f8e32aae7f01225e0e4d6763eaac40fc02dffc3d0b6a30f22d422147f9be4f3290ea78160a912ffae311dea3d503eb31a7a4f3999d3b541fbccd93d1cef4ca56
DIST pypy3.6-v7.3.2-src.tar.bz2 22736022 BLAKE2B e2338ac3f7af06b987c43e93eab9ff14d46262143472b0393b30b011fff67d33add45d8198cee7109354e09c52a2540938abeef364b0cf12f2891ca9c7aac2a4 SHA512 ed861a57d6edf1548c061d10295313a05d0ac54fe68a8755211ff76fa2dc78d7b1479c6152dc5d0d1cdce4e247c240c1a2edf59ec8a53d0004ec7713514c9c35
+DIST pypy3.6-v7.3.3-src.tar.bz2 22484684 BLAKE2B a252e3070ec1c7cfd708cd694bd461d56241100463bac5ff7bbcf2d2667e01990ec8b4ceb947449ab1f620d0d5a8984bd8af3e2565555e5f73218e3c35ae1ebd SHA512 3bc9d9cc362f500e9e79c2694fc355706ac44d6dd5b8f5fb4d017d0997581472a9fdda08ccbe45469c7b52facdc0512be07843ba54d1d691fdb37f6628065879
DIST pypy3.6-v7.3.3rc1-src.tar.bz2 22401663 BLAKE2B 278b71a3b608999ee20b6558598eda453f3a87645965b8b705a11d05784722106c04b405375f62bd8e7ce2968df311314ee1672a2ddecb0f6afc49a3cbe8e670 SHA512 d865125925603e74412be7e750ab403670f05e76f2dfe6280c8b0ef123ed3e2f463d9457b65aa4f84c47a3529b2d3bca84b84307623bf995f60b549c85dcce2d
DIST pypy3.7-v7.3.2-src.tar.bz2 25060911 BLAKE2B 35ecfee4c64e13539827c65a61e0cd359de4046f77553629cdf63479327c6ad86afd1443caa7a911a6271f496f0f3caf1b919ce91de717d0a71d008927b7f77b SHA512 563a9cf63e818b95aeb14c25b55bb5fb0bf8283f0b9f2bdd9a8833989beb651681f53f52368fb9db2c75fb60be0456eec87d48b557740b57847c4104003cb288
+DIST pypy3.7-v7.3.3-src.tar.bz2 24633503 BLAKE2B 0fb9fbb8866cf661c5b1d8d029fb2bc50737fae097875d0dac86c9ec21dc907093173b350a4f89d2c5a1fbed4c92ca4919f047536b828d4ee35583d615e7ddce SHA512 c98955e72dc0bd0452e4e16e0fe0ab318a34d6d57217ea33349e98ed047597ba97be7d15b41edd4dc85028fcca0a6257a4bb98fe96ce876e41a04df012261f4a
DIST pypy3.7-v7.3.3rc1-src.tar.bz2 24511164 BLAKE2B 7fba1fde1bb248006f95fbb52dd9f237086f7221b99d6a288c1a32188a76ed76b1908e7f2054fd969b597c422c566214dd1e9ec409e243a776e8fa466fbf2039 SHA512 f98e7d209f75c4fa5645db16e1cc721ba80d44ad76030bd1c412800bb723ba528a83da89c8793a7e105d8391e72eeef7cb0198f9b30041178e90b628f14e5a3e
diff --git a/dev-python/pypy3-exe/pypy3-exe-7.3.3.ebuild b/dev-python/pypy3-exe/pypy3-exe-7.3.3.ebuild
new file mode 100644
index 000000000000..a8648c1e6ea9
--- /dev/null
+++ b/dev-python/pypy3-exe/pypy3-exe-7.3.3.ebuild
@@ -0,0 +1,156 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+# pypy3 needs to be built using python 2
+PYTHON_COMPAT=( python2_7 )
+inherit check-reqs pax-utils python-any-r1 toolchain-funcs
+
+MY_P=pypy3.6-v${PV/_/}
+DESCRIPTION="PyPy3 executable (build from source)"
+HOMEPAGE="https://pypy.org/"
+SRC_URI="https://buildbot.pypy.org/pypy/${MY_P}-src.tar.bz2"
+S="${WORKDIR}/${MY_P}-src"
+
+LICENSE="MIT"
+SLOT="${PV}"
+KEYWORDS="~amd64 ~arm64 ~ppc64 ~x86 ~amd64-linux ~x86-linux"
+IUSE="bzip2 +jit low-memory ncurses cpu_flags_x86_sse2"
+
+RDEPEND=">=sys-libs/zlib-1.1.3:0=
+ dev-libs/libffi:0=
+ virtual/libintl:0=
+ dev-libs/expat:0=
+ bzip2? ( app-arch/bzip2:0= )
+ ncurses? ( sys-libs/ncurses:0= )
+ !dev-python/pypy3-exe-bin:${PV}"
+DEPEND="${RDEPEND}"
+BDEPEND="
+ low-memory? ( dev-python/pypy )
+ !low-memory? (
+ || (
+ dev-python/pypy
+ dev-lang/python:2.7
+ )
+ )"
+
+check_env() {
+ if use low-memory; then
+ CHECKREQS_MEMORY="1750M"
+ use amd64 && CHECKREQS_MEMORY="3500M"
+ else
+ CHECKREQS_MEMORY="3G"
+ use amd64 && CHECKREQS_MEMORY="6G"
+ fi
+
+ check-reqs_pkg_pretend
+}
+
+pkg_pretend() {
+ [[ ${MERGE_TYPE} != binary ]] && check_env
+}
+
+pkg_setup() {
+ if [[ ${MERGE_TYPE} != binary ]]; then
+ check_env
+
+ # unset to allow forcing pypy below :)
+ use low-memory && EPYTHON=
+ if [[ ! ${EPYTHON} || ${EPYTHON} == pypy ]] &&
+ { has_version -b dev-python/pypy ||
+ has_version -b dev-python/pypy-bin; }
+ then
+ einfo "Using PyPy to perform the translation."
+ EPYTHON=pypy
+ else
+ einfo "Using ${EPYTHON:-python2} to perform the translation. Please note that upstream"
+ einfo "recommends using PyPy for that. If you wish to do so, please install"
+ einfo "dev-python/pypy and ensure that EPYTHON variable is unset."
+ python-any-r1_pkg_setup
+ fi
+ fi
+}
+
+src_configure() {
+ tc-export CC
+
+ local jit_backend
+ if use jit; then
+ jit_backend='--jit-backend='
+
+ # We only need the explicit sse2 switch for x86.
+ # On other arches we can rely on autodetection which uses
+ # compiler macros. Plus, --jit-backend= doesn't accept all
+ # the modern values...
+
+ if use x86; then
+ if use cpu_flags_x86_sse2; then
+ jit_backend+=x86
+ else
+ jit_backend+=x86-without-sse2
+ fi
+ else
+ jit_backend+=auto
+ fi
+ fi
+
+ local args=(
+ --no-shared
+ $(usex jit -Ojit -O2)
+
+ ${jit_backend}
+
+ pypy/goal/targetpypystandalone
+ )
+
+ # Avoid linking against libraries disabled by use flags
+ local opts=(
+ bzip2:bz2
+ ncurses:_minimal_curses
+ )
+
+ local opt
+ for opt in "${opts[@]}"; do
+ local flag=${opt%:*}
+ local mod=${opt#*:}
+
+ args+=(
+ $(usex ${flag} --withmod --withoutmod)-${mod}
+ )
+ done
+
+ local interp=( "${EPYTHON}" )
+ if use low-memory; then
+ interp=( env PYPY_GC_MAX_DELTA=200MB
+ "${EPYTHON}" --jit loop_longevity=300 )
+ fi
+
+ if [[ ${EPYTHON} != pypy ]]; then
+ # reuse bundled pycparser to avoid external dep
+ mkdir -p "${T}"/pymod/cffi || die
+ : > "${T}"/pymod/cffi/__init__.py || die
+ cp -r lib_pypy/cffi/_pycparser "${T}"/pymod/cffi/ || die
+ local -x PYTHONPATH=${T}/pymod:${PYTHONPATH}
+ fi
+
+ # translate into the C sources
+ # we're going to build them ourselves since otherwise pypy does not
+ # free up the unneeded memory before spawning the compiler
+ set -- "${interp[@]}" rpython/bin/rpython --batch --source "${args[@]}"
+ echo -e "\033[1m${@}\033[0m"
+ "${@}" || die "translation failed"
+}
+
+src_compile() {
+ emake -C "${T}"/usession*-0/testing_1
+}
+
+src_install() {
+ local dest=/usr/lib/pypy3.6
+ exeinto "${dest}"
+ newexe "${T}"/usession*-0/testing_1/pypy3-c pypy3-c-${PV}
+ insinto "${dest}"/include/${PV}
+ doins include/pypy_*
+ pax-mark m "${ED}${dest}/pypy3-c-${PV}"
+}
diff --git a/dev-python/pypy3-exe/pypy3-exe-7.3.3_p37.ebuild b/dev-python/pypy3-exe/pypy3-exe-7.3.3_p37.ebuild
new file mode 100644
index 000000000000..5992fb3e87ef
--- /dev/null
+++ b/dev-python/pypy3-exe/pypy3-exe-7.3.3_p37.ebuild
@@ -0,0 +1,157 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+# pypy3 needs to be built using python 2
+PYTHON_COMPAT=( python2_7 )
+inherit check-reqs pax-utils python-any-r1 toolchain-funcs
+
+PYPY_PV=${PV%_p37}
+MY_P=pypy3.7-v${PYPY_PV/_/}
+DESCRIPTION="PyPy3 executable (build from source)"
+HOMEPAGE="https://pypy.org/"
+SRC_URI="https://buildbot.pypy.org/pypy/${MY_P}-src.tar.bz2"
+S="${WORKDIR}/${MY_P}-src"
+
+LICENSE="MIT"
+SLOT="${PV}"
+KEYWORDS="~amd64 ~arm64 ~ppc64 ~x86 ~amd64-linux ~x86-linux"
+IUSE="bzip2 +jit low-memory ncurses cpu_flags_x86_sse2"
+
+RDEPEND=">=sys-libs/zlib-1.1.3:0=
+ dev-libs/libffi:0=
+ virtual/libintl:0=
+ dev-libs/expat:0=
+ bzip2? ( app-arch/bzip2:0= )
+ ncurses? ( sys-libs/ncurses:0= )
+ !dev-python/pypy3-exe-bin:${PV}"
+DEPEND="${RDEPEND}"
+BDEPEND="
+ low-memory? ( dev-python/pypy )
+ !low-memory? (
+ || (
+ dev-python/pypy
+ dev-lang/python:2.7
+ )
+ )"
+
+check_env() {
+ if use low-memory; then
+ CHECKREQS_MEMORY="1750M"
+ use amd64 && CHECKREQS_MEMORY="3500M"
+ else
+ CHECKREQS_MEMORY="3G"
+ use amd64 && CHECKREQS_MEMORY="6G"
+ fi
+
+ check-reqs_pkg_pretend
+}
+
+pkg_pretend() {
+ [[ ${MERGE_TYPE} != binary ]] && check_env
+}
+
+pkg_setup() {
+ if [[ ${MERGE_TYPE} != binary ]]; then
+ check_env
+
+ # unset to allow forcing pypy below :)
+ use low-memory && EPYTHON=
+ if [[ ! ${EPYTHON} || ${EPYTHON} == pypy ]] &&
+ { has_version -b dev-python/pypy ||
+ has_version -b dev-python/pypy-bin; }
+ then
+ einfo "Using PyPy to perform the translation."
+ EPYTHON=pypy
+ else
+ einfo "Using ${EPYTHON:-python2} to perform the translation. Please note that upstream"
+ einfo "recommends using PyPy for that. If you wish to do so, please install"
+ einfo "dev-python/pypy and ensure that EPYTHON variable is unset."
+ python-any-r1_pkg_setup
+ fi
+ fi
+}
+
+src_configure() {
+ tc-export CC
+
+ local jit_backend
+ if use jit; then
+ jit_backend='--jit-backend='
+
+ # We only need the explicit sse2 switch for x86.
+ # On other arches we can rely on autodetection which uses
+ # compiler macros. Plus, --jit-backend= doesn't accept all
+ # the modern values...
+
+ if use x86; then
+ if use cpu_flags_x86_sse2; then
+ jit_backend+=x86
+ else
+ jit_backend+=x86-without-sse2
+ fi
+ else
+ jit_backend+=auto
+ fi
+ fi
+
+ local args=(
+ --no-shared
+ $(usex jit -Ojit -O2)
+
+ ${jit_backend}
+
+ pypy/goal/targetpypystandalone
+ )
+
+ # Avoid linking against libraries disabled by use flags
+ local opts=(
+ bzip2:bz2
+ ncurses:_minimal_curses
+ )
+
+ local opt
+ for opt in "${opts[@]}"; do
+ local flag=${opt%:*}
+ local mod=${opt#*:}
+
+ args+=(
+ $(usex ${flag} --withmod --withoutmod)-${mod}
+ )
+ done
+
+ local interp=( "${EPYTHON}" )
+ if use low-memory; then
+ interp=( env PYPY_GC_MAX_DELTA=200MB
+ "${EPYTHON}" --jit loop_longevity=300 )
+ fi
+
+ if [[ ${EPYTHON} != pypy ]]; then
+ # reuse bundled pycparser to avoid external dep
+ mkdir -p "${T}"/pymod/cffi || die
+ : > "${T}"/pymod/cffi/__init__.py || die
+ cp -r lib_pypy/cffi/_pycparser "${T}"/pymod/cffi/ || die
+ local -x PYTHONPATH=${T}/pymod:${PYTHONPATH}
+ fi
+
+ # translate into the C sources
+ # we're going to build them ourselves since otherwise pypy does not
+ # free up the unneeded memory before spawning the compiler
+ set -- "${interp[@]}" rpython/bin/rpython --batch --source "${args[@]}"
+ echo -e "\033[1m${@}\033[0m"
+ "${@}" || die "translation failed"
+}
+
+src_compile() {
+ emake -C "${T}"/usession*-0/testing_1
+}
+
+src_install() {
+ local dest=/usr/lib/pypy3.7
+ exeinto "${dest}"
+ newexe "${T}"/usession*-0/testing_1/pypy3-c pypy3-c-${PYPY_PV}
+ insinto "${dest}"/include/${PYPY_PV}
+ doins include/pypy_*
+ pax-mark m "${ED}${dest}/pypy3-c-${PYPY_PV}"
+}
diff --git a/dev-python/pypy3/Manifest b/dev-python/pypy3/Manifest
index 09c8da41a5db..06254507392c 100644
--- a/dev-python/pypy3/Manifest
+++ b/dev-python/pypy3/Manifest
@@ -1,5 +1,7 @@
DIST pypy3.6-v7.3.1-src.tar.bz2 22712809 BLAKE2B 4250b3fe98c611b9635319c106b80e88ab469eab5f883babb738e175e7b7adc22c85f8ef3fdce1cdc127b521beef8d6c7862e188d8c8889c39f90136d6bbe374 SHA512 f8e32aae7f01225e0e4d6763eaac40fc02dffc3d0b6a30f22d422147f9be4f3290ea78160a912ffae311dea3d503eb31a7a4f3999d3b541fbccd93d1cef4ca56
DIST pypy3.6-v7.3.2-src.tar.bz2 22736022 BLAKE2B e2338ac3f7af06b987c43e93eab9ff14d46262143472b0393b30b011fff67d33add45d8198cee7109354e09c52a2540938abeef364b0cf12f2891ca9c7aac2a4 SHA512 ed861a57d6edf1548c061d10295313a05d0ac54fe68a8755211ff76fa2dc78d7b1479c6152dc5d0d1cdce4e247c240c1a2edf59ec8a53d0004ec7713514c9c35
+DIST pypy3.6-v7.3.3-src.tar.bz2 22484684 BLAKE2B a252e3070ec1c7cfd708cd694bd461d56241100463bac5ff7bbcf2d2667e01990ec8b4ceb947449ab1f620d0d5a8984bd8af3e2565555e5f73218e3c35ae1ebd SHA512 3bc9d9cc362f500e9e79c2694fc355706ac44d6dd5b8f5fb4d017d0997581472a9fdda08ccbe45469c7b52facdc0512be07843ba54d1d691fdb37f6628065879
DIST pypy3.6-v7.3.3rc1-src.tar.bz2 22401663 BLAKE2B 278b71a3b608999ee20b6558598eda453f3a87645965b8b705a11d05784722106c04b405375f62bd8e7ce2968df311314ee1672a2ddecb0f6afc49a3cbe8e670 SHA512 d865125925603e74412be7e750ab403670f05e76f2dfe6280c8b0ef123ed3e2f463d9457b65aa4f84c47a3529b2d3bca84b84307623bf995f60b549c85dcce2d
DIST pypy3.7-v7.3.2-src.tar.bz2 25060911 BLAKE2B 35ecfee4c64e13539827c65a61e0cd359de4046f77553629cdf63479327c6ad86afd1443caa7a911a6271f496f0f3caf1b919ce91de717d0a71d008927b7f77b SHA512 563a9cf63e818b95aeb14c25b55bb5fb0bf8283f0b9f2bdd9a8833989beb651681f53f52368fb9db2c75fb60be0456eec87d48b557740b57847c4104003cb288
+DIST pypy3.7-v7.3.3-src.tar.bz2 24633503 BLAKE2B 0fb9fbb8866cf661c5b1d8d029fb2bc50737fae097875d0dac86c9ec21dc907093173b350a4f89d2c5a1fbed4c92ca4919f047536b828d4ee35583d615e7ddce SHA512 c98955e72dc0bd0452e4e16e0fe0ab318a34d6d57217ea33349e98ed047597ba97be7d15b41edd4dc85028fcca0a6257a4bb98fe96ce876e41a04df012261f4a
DIST pypy3.7-v7.3.3rc1-src.tar.bz2 24511164 BLAKE2B 7fba1fde1bb248006f95fbb52dd9f237086f7221b99d6a288c1a32188a76ed76b1908e7f2054fd969b597c422c566214dd1e9ec409e243a776e8fa466fbf2039 SHA512 f98e7d209f75c4fa5645db16e1cc721ba80d44ad76030bd1c412800bb723ba528a83da89c8793a7e105d8391e72eeef7cb0198f9b30041178e90b628f14e5a3e
diff --git a/dev-python/pypy3/pypy3-7.3.3.ebuild b/dev-python/pypy3/pypy3-7.3.3.ebuild
new file mode 100644
index 000000000000..c0706600dea4
--- /dev/null
+++ b/dev-python/pypy3/pypy3-7.3.3.ebuild
@@ -0,0 +1,207 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+PYTHON_COMPAT=( python2_7 )
+inherit pax-utils python-any-r1 toolchain-funcs
+
+MY_P=pypy3.6-v${PV/_/}
+
+DESCRIPTION="A fast, compliant alternative implementation of the Python (3.6) language"
+HOMEPAGE="https://pypy.org/"
+SRC_URI="https://buildbot.pypy.org/pypy/${MY_P}-src.tar.bz2"
+S="${WORKDIR}/${MY_P}-src"
+
+LICENSE="MIT"
+# pypy3 -c 'import sysconfig; print(sysconfig.get_config_var("SOABI"))'
+SLOT="0/pypy36-pp73"
+KEYWORDS="~amd64 ~arm64 ~ppc64 ~x86 ~amd64-linux ~x86-linux"
+IUSE="bzip2 gdbm +jit libressl ncurses sqlite test tk"
+RESTRICT="!test? ( test )"
+
+RDEPEND="
+ || (
+ dev-python/pypy3-exe:${PV}[bzip2?,ncurses?]
+ dev-python/pypy3-exe-bin:${PV}
+ )
+ !libressl? ( dev-libs/openssl:0= )
+ libressl? ( dev-libs/libressl:0= )
+ gdbm? ( sys-libs/gdbm:0= )
+ sqlite? ( dev-db/sqlite:3= )
+ tk? (
+ dev-lang/tk:0=
+ dev-tcltk/tix:0=
+ )
+ !<dev-python/pypy3-bin-7.3.0:0"
+DEPEND="${RDEPEND}
+ test? (
+ ${PYTHON_DEPS}
+ !!dev-python/pytest-forked
+ )"
+
+pkg_setup() {
+ use test && python-any-r1_pkg_setup
+}
+
+src_prepare() {
+ eapply "${FILESDIR}/7.3.1-gentoo-path.patch"
+ eapply "${FILESDIR}/1.9-distutils.unixccompiler.UnixCCompiler.runtime_library_dir_option.patch"
+ eapply "${FILESDIR}"/7.2.0-distutils-cxx.patch
+
+ sed -e "s^@EPREFIX@^${EPREFIX}^" \
+ -i lib-python/3/distutils/command/install.py || die
+
+ # apply CPython stdlib patches
+ pushd lib-python/3 > /dev/null || die
+ eapply "${FILESDIR}"/python-3.5-distutils-OO-build.patch
+ popd > /dev/null || die
+
+ # see http://buildbot.pypy.org/summary?branch=py3.6&builder=pypy-c-jit-linux-x86-64
+ sed -i -e 's:test_jumpy:_&:' \
+ lib-python/3/test/test_dis.py || die
+ sed -i -e 's:test_get_and_set_scheduler_and_param:_&:' \
+ lib-python/3/test/test_posix.py || die
+ sed -i -e 's:test_auto_history:_&:' \
+ -e 's:test_history_size:_&:' \
+ lib-python/3/test/test_readline.py || die
+ sed -i -e 's:test_eval_bytes_invalid_escape:_&:' \
+ -e 's:test_eval_str_invalid_escape:_&:' \
+ lib-python/3/test/test_string_literals.py || die
+ sed -i -e 's:test_jump_out_of_async_for_block:_&:' \
+ -e 's:test_jump_over_async_for_block_before_else:_&:' \
+ -e 's:test_no_jump_.*wards_into_async_for_block:_&:' \
+ -e 's:test_no_jump_into_async_for_block_before_else:_&:' \
+ -e 's:test_no_jump_from_yield:_&:' \
+ lib-python/3/test/test_sys_settrace.py || die
+ sed -i -e 's:test_circular_imports:_&:' \
+ lib-python/3/test/test_threaded_import.py || die
+
+ # the first one's broken by sandbox, the second by our env
+ sed -i -e 's:test_empty_env:_&:' \
+ -e 's:test_executable(:_&:' \
+ -e 's:test_executable_without_cwd:_&:' \
+ lib-python/3/test/test_subprocess.py || die
+
+ # XXX
+ sed -i -e 's:test_locale:_&:' \
+ lib-python/3/test/test_format.py || die
+ sed -i -e 's:test_decompressor_bug_28275:_&:' \
+ lib-python/3/test/test_lzma.py || die
+
+ eapply_user
+}
+
+src_configure() {
+ tc-export CC
+}
+
+src_compile() {
+ # copy over to make sys.prefix happy
+ cp -p "${BROOT}"/usr/lib/pypy3.6/pypy3-c-${PV} pypy3-c || die
+ cp -p "${BROOT}"/usr/lib/pypy3.6/include/${PV}/* include/ || die
+ # (not installed by pypy)
+ rm pypy/module/cpyext/include/_numpypy/numpy/README || die
+ mv pypy/module/cpyext/include/* include/ || die
+ mv pypy/module/cpyext/parse/*.h include/ || die
+ pax-mark m pypy3-c
+
+ einfo "Generating caches and CFFI modules ..."
+
+ # Generate Grammar and PatternGrammar pickles.
+ ./pypy3-c -c "import lib2to3.pygram, lib2to3.patcomp; lib2to3.patcomp.PatternCompiler()" \
+ || die "Generation of Grammar and PatternGrammar pickles failed"
+
+ # Generate cffi modules
+ # Please keep in sync with pypy/tool/build_cffi_imports.py!
+#cffi_build_scripts = {
+# "_blake2": "_blake2/_blake2_build.py",
+# "_ssl": "_ssl_build.py",
+# "sqlite3": "_sqlite3_build.py",
+# "audioop": "_audioop_build.py",
+# "tk": "_tkinter/tklib_build.py",
+# "curses": "_curses_build.py" if sys.platform != "win32" else None,
+# "syslog": "_syslog_build.py" if sys.platform != "win32" else None,
+# "gdbm": "_gdbm_build.py" if sys.platform != "win32" else None,
+# "pwdgrp": "_pwdgrp_build.py" if sys.platform != "win32" else None,
+# "resource": "_resource_build.py" if sys.platform != "win32" else None,
+# "lzma": "_lzma_build.py",
+# "_decimal": "_decimal_build.py",
+# "_sha3": "_sha3/_sha3_build.py",
+ cffi_targets=( blake2/_blake2 sha3/_sha3 ssl
+ audioop syslog pwdgrp resource lzma decimal )
+ use gdbm && cffi_targets+=( gdbm )
+ use ncurses && cffi_targets+=( curses )
+ use sqlite && cffi_targets+=( sqlite3 )
+ use tk && cffi_targets+=( tkinter/tklib )
+
+ local t
+ # all modules except tkinter output to .
+ # tkinter outputs to the correct dir ...
+ cd lib_pypy || die
+ for t in "${cffi_targets[@]}"; do
+ # tkinter doesn't work via -m
+ ../pypy3-c "_${t}_build.py" || die "Failed to build CFFI bindings for ${t}"
+ done
+
+ # Cleanup temporary objects
+ find -name "_cffi_*.[co]" -delete || die
+ find -type d -empty -delete || die
+}
+
+src_test() {
+ # (unset)
+ local -x PYTHONDONTWRITEBYTECODE=
+ local -x COLUMNS=80
+
+ # Test runner requires Python 2 too. However, it spawns PyPy3
+ # internally so that we end up testing the correct interpreter.
+ "${EPYTHON}" ./pypy/test_all.py --pypy=./pypy3-c -vv lib-python || die
+}
+
+src_install() {
+ local dest=/usr/lib/pypy3.6
+ einfo "Installing PyPy ..."
+ dosym pypy3-c-${PV} "${dest}/pypy3-c"
+ insinto "${dest}"
+ # preserve mtimes to avoid obsoleting caches
+ insopts -p
+ doins -r include lib_pypy lib-python
+
+ # replace copied headers with symlinks
+ for x in "${BROOT}"/usr/lib/pypy3.6/include/${PV}/*; do
+ dosym "${PV}/${x##*/}" "${dest}/include/${x##*/}"
+ done
+
+ dosym ../lib/pypy3.6/pypy3-c /usr/bin/pypy3
+ dodoc README.rst
+
+ if ! use gdbm; then
+ rm -r "${ED}${dest}"/lib_pypy/_gdbm* || die
+ fi
+ if ! use sqlite; then
+ rm -r "${ED}${dest}"/lib-python/*3/sqlite3 \
+ "${ED}${dest}"/lib_pypy/_sqlite3* \
+ "${ED}${dest}"/lib-python/*3/test/test_sqlite.py || die
+ fi
+ if ! use tk; then
+ rm -r "${ED}${dest}"/lib-python/*3/{idlelib,tkinter} \
+ "${ED}${dest}"/lib_pypy/_tkinter \
+ "${ED}${dest}"/lib-python/*3/test/test_{tcl,tk,ttk*}.py || die
+ fi
+
+ local -x EPYTHON=pypy3
+ local -x PYTHON=${ED}${dest}/pypy3-c-${PV}
+ # temporarily copy to build tree to facilitate module builds
+ cp -p "${BROOT}${dest}/pypy3-c-${PV}" "${PYTHON}" || die
+
+ echo "EPYTHON='${EPYTHON}'" > epython.py || die
+ python_moduleinto /usr/lib/pypy3.6/site-packages
+ python_domodule epython.py
+
+ einfo "Byte-compiling Python standard library..."
+ python_optimize "${ED}${dest}"
+
+ # remove to avoid collisions
+ rm "${PYTHON}" || die
+}
diff --git a/dev-python/pypy3/pypy3-7.3.3_p37.ebuild b/dev-python/pypy3/pypy3-7.3.3_p37.ebuild
new file mode 100644
index 000000000000..9c1fc7d860ba
--- /dev/null
+++ b/dev-python/pypy3/pypy3-7.3.3_p37.ebuild
@@ -0,0 +1,178 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+PYTHON_COMPAT=( python2_7 )
+inherit pax-utils python-any-r1 toolchain-funcs
+
+PYPY_PV=${PV%_p37}
+MY_P=pypy3.7-v${PYPY_PV/_/}
+
+DESCRIPTION="A fast, compliant alternative implementation of the Python (3.7) language"
+HOMEPAGE="https://pypy.org/"
+SRC_URI="https://buildbot.pypy.org/pypy/${MY_P}-src.tar.bz2"
+S="${WORKDIR}/${MY_P}-src"
+
+LICENSE="MIT"
+# pypy3 -c 'import sysconfig; print(sysconfig.get_config_var("SOABI"))'
+SLOT="0/pypy37-pp73"
+KEYWORDS="~amd64 ~arm64 ~ppc64 ~x86 ~amd64-linux ~x86-linux"
+IUSE="bzip2 gdbm +jit libressl ncurses sqlite test tk"
+# pypy3.7 is in alpha state and a lot of tests are failing
+RESTRICT="test"
+
+RDEPEND="
+ || (
+ dev-python/pypy3-exe:${PV}[bzip2?,ncurses?]
+ dev-python/pypy3-exe-bin:${PV}
+ )
+ !libressl? ( dev-libs/openssl:0= )
+ libressl? ( dev-libs/libressl:0= )
+ gdbm? ( sys-libs/gdbm:0= )
+ sqlite? ( dev-db/sqlite:3= )
+ tk? (
+ dev-lang/tk:0=
+ dev-tcltk/tix:0=
+ )
+ !<dev-python/pypy3-bin-7.3.0:0"
+DEPEND="${RDEPEND}
+ test? (
+ ${PYTHON_DEPS}
+ !!dev-python/pytest-forked
+ )"
+
+pkg_setup() {
+ use test && python-any-r1_pkg_setup
+}
+
+src_prepare() {
+ eapply "${FILESDIR}/7.3.1-gentoo-path.patch"
+ eapply "${FILESDIR}/1.9-distutils.unixccompiler.UnixCCompiler.runtime_library_dir_option.patch"
+ eapply "${FILESDIR}/7.3.2-py37-distutils-cxx.patch"
+
+ sed -e "s^@EPREFIX@^${EPREFIX}^" \
+ -i lib-python/3/distutils/command/install.py || die
+
+ # apply CPython stdlib patches
+ pushd lib-python/3 > /dev/null || die
+ eapply "${FILESDIR}"/python-3.5-distutils-OO-build.patch
+ popd > /dev/null || die
+
+ eapply_user
+}
+
+src_configure() {
+ tc-export CC
+}
+
+src_compile() {
+ # copy over to make sys.prefix happy
+ cp -p "${BROOT}"/usr/lib/pypy3.7/pypy3-c-${PYPY_PV} pypy3-c || die
+ cp -p "${BROOT}"/usr/lib/pypy3.7/include/${PYPY_PV}/* include/ || die
+ # (not installed by pypy)
+ rm pypy/module/cpyext/include/_numpypy/numpy/README || die
+ mv pypy/module/cpyext/include/* include/ || die
+ mv pypy/module/cpyext/parse/*.h include/ || die
+ pax-mark m pypy3-c
+
+ einfo "Generating caches and CFFI modules ..."
+
+ # Generate Grammar and PatternGrammar pickles.
+ ./pypy3-c -c "import lib2to3.pygram, lib2to3.patcomp; lib2to3.patcomp.PatternCompiler()" \
+ || die "Generation of Grammar and PatternGrammar pickles failed"
+
+ # Generate cffi modules
+ # Please keep in sync with pypy/tool/build_cffi_imports.py!
+#cffi_build_scripts = {
+# "_blake2": "_blake2/_blake2_build.py",
+# "_ssl": "_ssl_build.py",
+# "sqlite3": "_sqlite3_build.py",
+# "audioop": "_audioop_build.py",
+# "tk": "_tkinter/tklib_build.py",
+# "curses": "_curses_build.py" if sys.platform != "win32" else None,
+# "syslog": "_syslog_build.py" if sys.platform != "win32" else None,
+# "gdbm": "_gdbm_build.py" if sys.platform != "win32" else None,
+# "pwdgrp": "_pwdgrp_build.py" if sys.platform != "win32" else None,
+# "resource": "_resource_build.py" if sys.platform != "win32" else None,
+# "lzma": "_lzma_build.py",
+# "_decimal": "_decimal_build.py",
+# "_sha3": "_sha3/_sha3_build.py",
+ cffi_targets=( blake2/_blake2 sha3/_sha3 ssl
+ audioop syslog pwdgrp resource lzma decimal )
+ use gdbm && cffi_targets+=( gdbm )
+ use ncurses && cffi_targets+=( curses )
+ use sqlite && cffi_targets+=( sqlite3 )
+ use tk && cffi_targets+=( tkinter/tklib )
+
+ local t
+ # all modules except tkinter output to .
+ # tkinter outputs to the correct dir ...
+ cd lib_pypy || die
+ for t in "${cffi_targets[@]}"; do
+ # tkinter doesn't work via -m
+ ../pypy3-c "_${t}_build.py" || die "Failed to build CFFI bindings for ${t}"
+ done
+
+ # Cleanup temporary objects
+ find -name "_cffi_*.[co]" -delete || die
+ find -type d -empty -delete || die
+}
+
+src_test() {
+ # (unset)
+ local -x PYTHONDONTWRITEBYTECODE=
+ local -x COLUMNS=80
+
+ # Test runner requires Python 2 too. However, it spawns PyPy3
+ # internally so that we end up testing the correct interpreter.
+ # (--deselect for failing doctests)
+ "${EPYTHON}" ./pypy/test_all.py --pypy=./pypy3-c -vv lib-python || die
+}
+
+src_install() {
+ local dest=/usr/lib/pypy3.7
+ einfo "Installing PyPy ..."
+ dosym pypy3-c-${PYPY_PV} "${dest}/pypy3-c"
+ insinto "${dest}"
+ # preserve mtimes to avoid obsoleting caches
+ insopts -p
+ doins -r include lib_pypy lib-python
+
+ # replace copied headers with symlinks
+ for x in "${BROOT}"/usr/lib/pypy3.7/include/${PYPY_PV}/*; do
+ dosym "${PYPY_PV}/${x##*/}" "${dest}/include/${x##*/}"
+ done
+
+ dosym ../lib/pypy3.7/pypy3-c /usr/bin/pypy3
+ dodoc README.rst
+
+ if ! use gdbm; then
+ rm -r "${ED}${dest}"/lib_pypy/_gdbm* || die
+ fi
+ if ! use sqlite; then
+ rm -r "${ED}${dest}"/lib-python/*3/sqlite3 \
+ "${ED}${dest}"/lib_pypy/_sqlite3* \
+ "${ED}${dest}"/lib-python/*3/test/test_sqlite.py || die
+ fi
+ if ! use tk; then
+ rm -r "${ED}${dest}"/lib-python/*3/{idlelib,tkinter} \
+ "${ED}${dest}"/lib_pypy/_tkinter \
+ "${ED}${dest}"/lib-python/*3/test/test_{tcl,tk,ttk*}.py || die
+ fi
+
+ local -x EPYTHON=pypy3
+ local -x PYTHON=${ED}${dest}/pypy3-c-${PYPY_PV}
+ # temporarily copy to build tree to facilitate module builds
+ cp -p "${BROOT}${dest}/pypy3-c-${PYPY_PV}" "${PYTHON}" || die
+
+ echo "EPYTHON='${EPYTHON}'" > epython.py || die
+ python_moduleinto /usr/lib/pypy3.7/site-packages
+ python_domodule epython.py
+
+ einfo "Byte-compiling Python standard library..."
+ python_optimize "${ED}${dest}"
+
+ # remove to avoid collisions
+ rm "${PYTHON}" || die
+}
diff --git a/dev-python/python-utils/python-utils-2.3.0.ebuild b/dev-python/python-utils/python-utils-2.3.0.ebuild
index e1de4d4a4e1e..a1c956fcfe7a 100644
--- a/dev-python/python-utils/python-utils-2.3.0.ebuild
+++ b/dev-python/python-utils/python-utils-2.3.0.ebuild
@@ -3,7 +3,6 @@
EAPI=7
PYTHON_COMPAT=( python3_{5,6,7,8,9} pypy3 )
-PATCHES=( "${FILESDIR}"/${P}-pytest-runner.patch )
inherit distutils-r1
@@ -15,17 +14,15 @@ LICENSE="BSD"
SLOT="0"
KEYWORDS="~amd64"
-RDEPEND="dev-python/setuptools[${PYTHON_USEDEP}]
- dev-python/six[${PYTHON_USEDEP}]"
-BDEPEND="${RDEPEND}
- dev-python/pytest-flakes[${PYTHON_USEDEP}]"
+RDEPEND="dev-python/six[${PYTHON_USEDEP}]"
+
+PATCHES=( "${FILESDIR}"/${P}-pytest-runner.patch )
+
+distutils_enable_tests pytest
python_prepare_all() {
find . -name '__pycache__' -prune -exec rm -rf {} \; || die "Cleaning __pycache__ failed"
find . -name '*.pyc' -exec rm -f {} \; || die "Cleaning *.pyc failed"
+ sed -i -e '/--cov/d' -e '/--pep8/d' -e '/--flakes/d' pytest.ini || die
distutils-r1_python_prepare_all
}
-
-python_test() {
- pytest -v || die
-}
diff --git a/dev-python/tqdm/tqdm-4.53.0.ebuild b/dev-python/tqdm/tqdm-4.53.0.ebuild
index 2c6266cf90d3..f7e9ce01c97d 100644
--- a/dev-python/tqdm/tqdm-4.53.0.ebuild
+++ b/dev-python/tqdm/tqdm-4.53.0.ebuild
@@ -23,6 +23,10 @@ LICENSE="MIT"
SLOT="0"
IUSE="examples"
+BDEPEND="
+ dev-python/setuptools_scm[${PYTHON_USEDEP}]
+ dev-python/toml[${PYTHON_USEDEP}]"
+
distutils_enable_tests pytest
python_test() {